SET FEEDBACK OFF
SET HEADING OFF
SET ECHO OFF
set pagesize 0
set trim on
SET markup HTML ON
select (select sys_context('USERENV', 'INSTANCE_NAME') from dual) INSTANCE, (select sys_context('USERENV', 'DB_NAME') from dual) DB_NAME,
j.input_type, j.status,
TO_CHAR (j.start_time, 'yyyy/mm/dd hh24:mi:ss') start_time, 
TO_CHAR (j.end_time, 'yyyy/mm/dd hh24:mi:ss') end_time, 
ROUND (j.elapsed_seconds) secs,
ROUND (j.elapsed_seconds / 60) mins, 
ROUND (j.elapsed_seconds / 60 / 60,2) hours, 
ROUND (j.input_bytes / 1024 / 1024) input_mb, 
ROUND (j.output_bytes / 1024 / 1024) output_mb, 
--j.INPUT_BYTES_PER_SEC_DISPLAY input_per_sec, 
--j.OUTPUT_BYTES_PER_SEC_DISPLAY output_per_sec, 
j.COMPRESSION_RATIO, j.session_recid, j.session_stamp, 
  to_char(j.start_time, 'DAY') DOW,
  j.elapsed_seconds, j.time_taken_display Time_Taken_hhmmss,
  x.cf, x.dcn, x.dcy, x.df, x.i0, x.i1, x.l--, ro.inst_id output_instance
from V$RMAN_BACKUP_JOB_DETAILS j 
  left outer join (select
                     d.session_recid, d.session_stamp,
                     sum(case when d.controlfile_included = 'YES' then d.pieces else 0 end) CF,
                     sum(case when d.controlfile_included = 'NO' and d.backup_type||d.incremental_level = 'D' then d.pieces else 0 end) DCN,
                     sum(case when d.controlfile_included = 'YES' and d.backup_type||d.incremental_level = 'D' then d.pieces else 0 end) DCY,
                     sum(case when d.backup_type||d.incremental_level = 'D' then d.pieces else 0 end) DF,
                     sum(case when d.backup_type||d.incremental_level = 'I0' then d.pieces else 0 end) I0,
                     sum(case when d.backup_type||d.incremental_level = 'I1' then d.pieces else 0 end) I1,
                     sum(case when d.backup_type = 'L' then d.pieces else 0 end) L
                   from
                     V$BACKUP_SET_DETAILS d
                     join V$BACKUP_SET s on s.set_stamp = d.set_stamp and s.set_count = d.set_count
                   where s.input_file_scan_only = 'NO'
                   group by d.session_recid, d.session_stamp) x
    on x.session_recid = j.session_recid and x.session_stamp = j.session_stamp
  left outer join (select o.session_recid, o.session_stamp, min(inst_id) inst_id
                   from GV$RMAN_OUTPUT o
                   group by o.session_recid, o.session_stamp)
    ro on ro.session_recid = j.session_recid and ro.session_stamp = j.session_stamp
where j.start_time > trunc(sysdate)-3
--AND j.input_type != 'ARCHIVELOG'
AND j.status <> 'COMPLETED'
order by j.start_time DESC;
EXIT










