# This script performs the following actions: 
#  1) Read a list of servers 
#  2) For each server on the list, get disk drive information - drive letter, drive size, free space, percent free 
#  3) Email the report to users specified by the $users variable 
# 
$users = "jason.wong@somecompany.com,jason.wong@somecompany.com"
$ccTo = "jason.wong@somecompany.com"
$server = "email.somecompany.com" 
$port = 25 
Remove-Item C:\DiskSpaceMonitorEmail\output.csv
Remove-Item C:\DiskSpaceMonitorEmail\output.htmml
#$output = $args[0] 
$PercentAlert = 85
$AlertHighWaterMark = 0
$output = "C:\DiskSpaceMonitorEmail\output.csv" 
#$echo "Disk Space Alert" > $output 
#echo " " >> $output 
#echo "Free space below threshold as shown below:" >> $output 
#echo " " >> $output 
echo "ServerName, Drive Letter, Drive Size, Free Space, Percent Free" >> $output 
#echo "---------- `t------------ `t---------- `t---------- `t------------" >> $output 

foreach($computer in (gc C:\DiskSpaceMonitorEmail\servers.txt))
{ 
 $drives = Get-WmiObject -ComputerName $computer Win32_LogicalDisk | Where-Object {$_.DriveType -eq 3} 
	foreach($drive in $drives) 
	{ 
		$id = $drive.DeviceID 
		$size = [math]::round($drive.Size / 1073741824, 2) 
		if( $size -eq 0 ) { continue;}
		write-host $computer, $drive
		$free = [math]::round($drive.FreeSpace  / 1073741824, 2) 
		$pct = [math]::round($free / $size, 2) * 100 
		if ($pct -lt $PercentAlert) 
		{ 
			$AlertHighWaterMark = 1
			$pct = $pct.ToString() + "%" 
			echo "$computer, $id, $size, $free, $pct,"  >> $output 
			$pct = 0  
		} 
		# else {  $pct = $pct.ToString() + " %" } 
		else { }
	} 
} 

try{
#import-csv C:\DiskSpaceMonitorEmail\output.csv | ConvertTo-Html | Out-File -append C:\DiskSpaceMonitorEmail\output.html
import-csv C:\DiskSpaceMonitorEmail\output.csv | ConvertTo-Html | Out-File C:\DiskSpaceMonitorEmail\output.html
$fromaddress = "jason.wong@somecompany.com" 
$toaddress = "jason.wong@somecompany.com" 
$bccaddress = "jason.wong@somecompany.com" 
$CCaddress = "jason.wong@somecompany.com" 
$Subject = "Disk Space Alert -Free space below threshold as shown below:" 
$body = get-content C:\DiskSpaceMonitorEmail\output.html ##"See attachment" 
$att = "C:\DiskSpaceMonitorEmail\output.csv"
$smtpserver = "mail.somecompany.com" 
$SMTPPort = "25"
$Username = "xxxx\JasonW"
$Password = "xxxxxxxxxx"
$message = new-object System.Net.Mail.MailMessage 
$message.From = $fromaddress 
$message.To.Add($toaddress) 
$message.CC.Add($CCaddress) 
$message.Bcc.Add($bccaddress) 
$message.IsBodyHtml = $True 
$message.Subject = $Subject 
$message.body = $body 
#$message.Attachments.Add($att)
$smtp = new-object Net.Mail.SmtpClient($smtpserver, $SMTPPort) 
$smtp.Credentials = New-Object System.Net.NetworkCredential($Username, $Password);
$smtp.Send($message)
write-host "Finally completed."
}
catch
{
        write-host $server
        write-host "Caught an exception:" -ForegroundColor Red
        write-host "Exception Type: $($_.Exception.GetType().FullName)" -ForegroundColor Red
        write-host "Exception Message: $($_.Exception.Message)" -ForegroundColor Red
        write-host $server.server_name -ForegroundColor Red
}
finally
{
        #Remove-Item C:\DiskSpaceMonitorEmail\output.csv
}
#exit
# End of Script 

