#!/bin/ksh 

active_trans_archivelog()
{
    SQLPLUS -s /nolog <<EOF
    connect Username/password@PRODPRI
    SET FEEDBACK OFF
    SET HEADING OFF
    SET ECHO OFF
    SET pagesize 0
    SET trim on
    SET markup HTML ON
    spool /home/oracle/DBA/scripts/TMP/active_trans_archivelog.html
    select al.name, al.thread#, al.sequence#, al.status, al.first_time, al.next_time, al.first_change#, al.next_change#, t.START_SCN, t.START_SCNW, t.START_SCNB, t.XIDSQN, t.start_time,s.sid,s.serial#,s.username,s.status SESS_STATUS,s.schemaname,
      s.osuser,s.process,s.machine,s.terminal,s.program,s.module,to_char(s.logon_time,'DD/MON/YY HH24:MI:SS') logon_time, s.blocking_session_status, t.status TRAN_STATUS
      from v\$transaction t, v\$session s, v\$archived_log al
      where s.saddr = t.ses_addr
      AND t.START_SCN between al.first_change# and al.next_change#
      order by start_time;
spool off
EXIT;
EOF
}

sb_applied_log()
{
    SQLPLUS -s /nolog <<EOF
    connect / as sysdba
    SET FEEDBACK OFF
    SET HEADING OFF
    SET ECHO OFF
    SET pagesize 0
    SET trim on
    SET markup HTML ON
    spool /home/oracle/DBA/scripts/TMP/sb_applied_log.html
    select al.RECID, al.STAMP, al.NAME, al.DEST_ID, al.THREAD#, al.SEQUENCE#, to_char(al.FIRST_TIME, 'YYYY-MM-DD HH24:MI:SS') FIRSTTIME, al.ARCHIVED, al.REGISTRAR, al.APPLIED, to_char(al.COMPLETION_TIME, 'YYYY-MM-DD HH24:MI:SS'), round(24*60*(al.COMPLETION_TIME - al.FIRST_TIME), 3)	MINS 
 	from v\$archived_log al
 	where resetlogs_change#=(select resetlogs_change# from v$database) AND to_date(first_time) > sysdate -1 order by al.sequence# DESC;
spool off
EXIT;
EOF
}

p=`sqlplus -silent Username/password@PRODPRI <<endl | grep KEEP | sed 's/KEEP//;s/[ ]//g' 
select 'KEEP' , max(sequence#) from "V\\\$ARCHIVED_LOG" where resetlogs_change#=(select resetlogs_change# from "V\\\$DATABASE");
exit 
endl` 
echo $p 

s=`sqlplus / as sysdba <<endl | grep KEEP | sed 's/KEEP//;s/[ ]//g' 
select 'KEEP' , max(sequence#) from "V\\\$ARCHIVED_LOG" where resetlogs_change#=(select resetlogs_change# from "V\\\$DATABASE");exit 
endl` 
echo $s 

if [ ${p} != ${s} ]; then
  echo "archivelog lag."
  active_trans_archivelog;
  mailx -a 'Content-Type: text/html' -s "Archivelog lag - Primary: $p, Standby: $s" jason.wong@calumetspecialty.com < /home/oracle/DBA/scripts/TMP/active_trans_archivelog.html
  sb_applied_log();
  mailx -a 'Content-Type: text/html' -s "Standby applied log sequence" jason.wong@calumetspecialty.com < /home/oracle/DBA/scripts/TMP/sb_applied_log.html
fi
rm /home/oracle/DBA/scripts/TMP/active_trans_archivelog.html
rm /home/oracle/DBA/scripts/TMP/sb_applied_log.html

applyloglag=`sqlplus / as sysdba <<endl | grep KEEP | sed 's/KEEP//;s/[ ]//g' 
select 'KEEP',  
	to_char(almax - lhmax) from
	(select thread# thrd, max(sequence#) almax
 	from "V\\\$ARCHIVED_LOG"
 	where resetlogs_change#=(select resetlogs_change# from "V\\\$DATABASE")
 	group by thread#) al,
	(select thread# thrd, max(sequence#) lhmax, max(first_time) applied_time
 	from "V\\\$LOG_HISTORY"
 	where first_time=(select max(first_time) from "V\\\$LOG_HISTORY")
 	group by thread#) lh,
	(select thread# thrd from "V\\\$LOG_HISTORY" group by thread#) la
	where al.thrd = lh.thrd
	and la.thrd(+)=lh.thrd;
exit 
endl` 
echo $applyloglag

if [ ${$applyloglag} != "0" ]; then
   echo "redo apply lag."
   mailx -s "Redo apply lag - Standby: $applyloglag" jason.wong@calumetspecialty.com    
fi
