#!/bin/ksh
export ORACLE_HOME=/oracle/app/oracle/product/12.2.0/dbhome_1
export ORACLE_BASE=/oracle/app/oracle/
export LIBPATH=$ORACLE_HOME/lib
export LD_LIBRARY_PATH=$ORACLE_HOME/lib:$ORACLE_HOME/network/lib
export PATH=$PATH:$ORACLE_HOME/bin:$ORACLE_HOME/OPatch
export ORACLE_SID=ORCL122
export ORACLE_UNQNAME=ORCL122
SCRIPT_LOG=/home/oracle/DBA/log
SCRIPT_TMP=/home/oracle/DBA/TMP
SCRIPT_SQL=/home/oracle/DBA/SQL

EXIT_CODE=0

cleanup () {
find $1 -name '*' -mtime +$2 -exec rm -f {} \;
}

if [ "$1" = "" ]
then
   echo "Usage: $0 <DB_UNIQUE_NAME> "
   EXIT_CODE=100
   exit ${EXIT_CODE}
fi

DAY_PREFIX=`date | cut -c1-3`
##############

STARTTIME=`date +"%s"`
TIMESTAMP=`date +"%Y%m%d%H%M%S"`

BACKUP_TYPE=ARCH
LOG=${SCRIPT_LOG}/rman_${ORACLE_SID}_${BACKUP_TYPE}_${TIMESTAMP}.log
RMANCMD=${SCRIPT_SQL}/rman_arch_cloud.rman
EMAIL=jason.wong@somecompany.com
RMANDATE=`date +"%m-%d-%y %T"`

###################################################
$ORACLE_HOME/bin/rman log=$LOG <<EOF
connect target  /
@$RMANCMD
#rman cmdfile=DBIncr_Lvl1_Backup_3D.rman log=backup_ts_users.log
exit;
EOF
######################################################
##Linux
RC=`grep -e "RMAN-" -e "ORA-" -e "ERR" $LOG | grep -v "RMAN-08138" | grep -v "RMAN-08139" | grep -v "RMAN-08120" | wc -l | awk '{print $1}'`

if [ $RC -ne "0" ]; then
EXIT_CODE=1
mail -s "RMAN BACKUP of DATABASE <$ORACLE_SID> type <$BACKUP_TYPE> starting at <$RMANDATE> has FAILED" $EMAIL < $LOG
fi
cleanup ${SCRIPT_LOG} 365
cleanup ${SCRIPT_TMP} 30

exit ${EXIT_CODE}

